/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2019 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by pbtools.
 */

#ifndef ADDRESS_BOOK_H
#define ADDRESS_BOOK_H

#include "pbtools.h"

/**
 * Enum address_book.Person.PhoneType.
 */
enum address_book_person_phone_type_e {
    address_book_person_phone_type_mobile_e = 0,
    address_book_person_phone_type_home_e = 1,
    address_book_person_phone_type_work_e = 2
};

/**
 * Message address_book.Person.PhoneNumber.
 */
struct address_book_person_phone_number_repeated_t {
    int length;
    struct address_book_person_phone_number_t **items_pp;
    struct address_book_person_phone_number_t *head_p;
    struct address_book_person_phone_number_t *tail_p;
};

struct address_book_person_phone_number_t {
    struct pbtools_message_base_t base;
    struct pbtools_bytes_t number;
    enum address_book_person_phone_type_e type;
};

/**
 * Message address_book.Person.
 */
struct address_book_person_repeated_t {
    int length;
    struct address_book_person_t **items_pp;
    struct address_book_person_t *head_p;
    struct address_book_person_t *tail_p;
};

struct address_book_person_t {
    struct pbtools_message_base_t base;
    struct pbtools_bytes_t name;
    int32_t id;
    struct pbtools_bytes_t email;
    struct address_book_person_phone_number_repeated_t phones;
};

/**
 * Message address_book.AddressBook.
 */
struct address_book_address_book_repeated_t {
    int length;
    struct address_book_address_book_t **items_pp;
    struct address_book_address_book_t *head_p;
    struct address_book_address_book_t *tail_p;
};

struct address_book_address_book_t {
    struct pbtools_message_base_t base;
    struct address_book_person_repeated_t people;
};

int address_book_person_phones_alloc(
    struct address_book_person_t *self_p,
    int length);

/**
 * Create a new message address_book.Person in given workspace.
 *
 * @param[in] workspace_p Message workspace.
 * @param[in] size Workspace size.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct address_book_person_t *
address_book_person_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message address_book.Person.
 *
 * @param[in] self_p Message to encode.
 * @param[out] encoded_p Buffer to encode the message into.
 * @param[in] size Encoded buffer size.
 *
 * @return Encoded data length or negative error code.
 */
int address_book_person_encode(
    struct address_book_person_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message address_book.Person.
 *
 * @param[in,out] self_p Initialized message to decode into.
 * @param[in] encoded_p Buffer to decode.
 * @param[in] size Size of the encoded message.
 *
 * @return Number of bytes decoded or negative error code.
 */
int address_book_person_decode(
    struct address_book_person_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

int address_book_address_book_people_alloc(
    struct address_book_address_book_t *self_p,
    int length);

/**
 * Create a new message address_book.AddressBook in given workspace.
 *
 * @param[in] workspace_p Message workspace.
 * @param[in] size Workspace size.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct address_book_address_book_t *
address_book_address_book_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message address_book.AddressBook.
 *
 * @param[in] self_p Message to encode.
 * @param[out] encoded_p Buffer to encode the message into.
 * @param[in] size Encoded buffer size.
 *
 * @return Encoded data length or negative error code.
 */
int address_book_address_book_encode(
    struct address_book_address_book_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message address_book.AddressBook.
 *
 * @param[in,out] self_p Initialized message to decode into.
 * @param[in] encoded_p Buffer to decode.
 * @param[in] size Size of the encoded message.
 *
 * @return Number of bytes decoded or negative error code.
 */
int address_book_address_book_decode(
    struct address_book_address_book_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

#endif
