/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2019 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by pbtools version 0.2.0 Mon Aug 26 07:17:43 2019.
 */

#include "oneof.h"

static void oneof_message_value_encode(
    struct pbtools_encoder_t *encoder_p,
    struct oneof_message_value_oneof_t *oneof_p)
{
    switch (oneof_p->choice) {

    case oneof_message_value_choice_v1_e:
        pbtools_encoder_write_int32(encoder_p,
                                    1,
                                    oneof_p->value.v1);
        break;

    case oneof_message_value_choice_v2_e:
        pbtools_encoder_write_string(encoder_p,
                                     2,
                                     &oneof_p->value.v2);
        break;

    default:
        break;
    }
}

static void oneof_message_encode_inner(
    struct pbtools_encoder_t *encoder_p,
    struct oneof_message_t *self_p)
{
    oneof_message_value_encode(encoder_p, &self_p->value);
}

static void oneof_message_value_v1_decode(
    struct pbtools_decoder_t *decoder_p,
    int wire_type,
    struct oneof_message_value_oneof_t *oneof_p)
{
    oneof_p->choice = oneof_message_value_choice_v1_e;
    oneof_p->value.v1 = pbtools_decoder_read_int32(
        decoder_p,
        wire_type);
}

static void oneof_message_value_v2_decode(
    struct pbtools_decoder_t *decoder_p,
    int wire_type,
    struct oneof_message_value_oneof_t *oneof_p)
{
    oneof_p->choice = oneof_message_value_choice_v2_e;
    pbtools_decoder_read_string(decoder_p,
                                wire_type,
                                &oneof_p->value.v2);
}

static void oneof_message_decode_inner(
    struct pbtools_decoder_t *decoder_p,
    struct oneof_message_t *self_p)
{
    int wire_type;

    while (pbtools_decoder_available(decoder_p)) {
        switch (pbtools_decoder_read_tag(decoder_p, &wire_type)) {

        case 1:
            oneof_message_value_v1_decode(
                decoder_p,
                wire_type,
                &self_p->value);
            break;

        case 2:
            oneof_message_value_v2_decode(
                decoder_p,
                wire_type,
                &self_p->value);
            break;

        default:
            pbtools_decoder_skip_field(decoder_p, wire_type);
            break;
        }
    }
}

struct oneof_message_t *oneof_message_new(
    void *workspace_p,
    size_t size)
{
    struct oneof_message_t *self_p;
    struct pbtools_heap_t *heap_p;

    heap_p = pbtools_heap_new(workspace_p, size);

    if (heap_p == NULL) {
        return (NULL);
    }

    self_p = pbtools_heap_alloc(heap_p, sizeof(*self_p));

    if (self_p != NULL) {
        self_p->base.heap_p = heap_p;
        self_p->value.choice = oneof_message_value_choice_none_e;
    }

    return (self_p);
}

int oneof_message_encode(
    struct oneof_message_t *self_p,
    uint8_t *encoded_p,
    size_t size)
{
    return (pbtools_message_encode(
                &self_p->base,
                encoded_p,
                size,
                (pbtools_message_encode_inner_t)oneof_message_encode_inner));
}

int oneof_message_decode(
    struct oneof_message_t *self_p,
    const uint8_t *encoded_p,
    size_t size)
{
    return (pbtools_message_decode(
                &self_p->base,
                encoded_p,
                size,
                (pbtools_message_decode_inner_t)oneof_message_decode_inner));
}
