/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2019 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by pbtools.
 */

#ifndef REPEATED_H
#define REPEATED_H

#include "pbtools.h"

/**
 * Message repeated.Message.
 */
struct repeated_message_repeated_t {
    int length;
    struct repeated_message_t **items_pp;
    struct repeated_message_t *head_p;
    struct repeated_message_t *tail_p;
};

struct repeated_message_t {
    struct pbtools_message_base_t base;
    struct pbtools_repeated_int32_t int32s;
    struct repeated_message_repeated_t messages;
    struct pbtools_repeated_string_t strings;
    struct pbtools_repeated_bytes_t bytes;
};

/**
 * Message repeated.MessageScalarValueTypes.
 */
struct repeated_message_scalar_value_types_repeated_t {
    int length;
    struct repeated_message_scalar_value_types_t **items_pp;
    struct repeated_message_scalar_value_types_t *head_p;
    struct repeated_message_scalar_value_types_t *tail_p;
};

struct repeated_message_scalar_value_types_t {
    struct pbtools_message_base_t base;
    struct pbtools_repeated_int32_t int32s;
    struct pbtools_repeated_int64_t int64s;
    struct pbtools_repeated_int32_t sint32s;
    struct pbtools_repeated_int64_t sint64s;
    struct pbtools_repeated_uint32_t uint32s;
    struct pbtools_repeated_uint64_t uint64s;
    struct pbtools_repeated_uint32_t fixed32s;
    struct pbtools_repeated_uint64_t fixed64s;
    struct pbtools_repeated_int32_t sfixed32s;
    struct pbtools_repeated_int64_t sfixed64s;
    struct pbtools_repeated_float_t floats;
    struct pbtools_repeated_double_t doubles;
    struct pbtools_repeated_bool_t bools;
    struct pbtools_repeated_string_t strings;
    struct pbtools_repeated_bytes_t bytess;
};

int repeated_message_int32s_alloc(
    struct repeated_message_t *self_p,
    int length);

int repeated_message_messages_alloc(
    struct repeated_message_t *self_p,
    int length);

int repeated_message_strings_alloc(
    struct repeated_message_t *self_p,
    int length);

int repeated_message_bytes_alloc(
    struct repeated_message_t *self_p,
    int length);

/**
 * Create a new message repeated.Message in given workspace.
 *
 * @param[in] workspace_p Message workspace.
 * @param[in] size Workspace size.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct repeated_message_t *
repeated_message_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message repeated.Message.
 *
 * @param[in] self_p Message to encode.
 * @param[out] encoded_p Buffer to encode the message into.
 * @param[in] size Encoded buffer size.
 *
 * @return Encoded data length or negative error code.
 */
int repeated_message_encode(
    struct repeated_message_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message repeated.Message.
 *
 * @param[in,out] self_p Initialized message to decode into.
 * @param[in] encoded_p Buffer to decode.
 * @param[in] size Size of the encoded message.
 *
 * @return Number of bytes decoded or negative error code.
 */
int repeated_message_decode(
    struct repeated_message_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

int repeated_message_scalar_value_types_int32s_alloc(
    struct repeated_message_scalar_value_types_t *self_p,
    int length);

int repeated_message_scalar_value_types_int64s_alloc(
    struct repeated_message_scalar_value_types_t *self_p,
    int length);

int repeated_message_scalar_value_types_sint32s_alloc(
    struct repeated_message_scalar_value_types_t *self_p,
    int length);

int repeated_message_scalar_value_types_sint64s_alloc(
    struct repeated_message_scalar_value_types_t *self_p,
    int length);

int repeated_message_scalar_value_types_uint32s_alloc(
    struct repeated_message_scalar_value_types_t *self_p,
    int length);

int repeated_message_scalar_value_types_uint64s_alloc(
    struct repeated_message_scalar_value_types_t *self_p,
    int length);

int repeated_message_scalar_value_types_fixed32s_alloc(
    struct repeated_message_scalar_value_types_t *self_p,
    int length);

int repeated_message_scalar_value_types_fixed64s_alloc(
    struct repeated_message_scalar_value_types_t *self_p,
    int length);

int repeated_message_scalar_value_types_sfixed32s_alloc(
    struct repeated_message_scalar_value_types_t *self_p,
    int length);

int repeated_message_scalar_value_types_sfixed64s_alloc(
    struct repeated_message_scalar_value_types_t *self_p,
    int length);

int repeated_message_scalar_value_types_floats_alloc(
    struct repeated_message_scalar_value_types_t *self_p,
    int length);

int repeated_message_scalar_value_types_doubles_alloc(
    struct repeated_message_scalar_value_types_t *self_p,
    int length);

int repeated_message_scalar_value_types_bools_alloc(
    struct repeated_message_scalar_value_types_t *self_p,
    int length);

int repeated_message_scalar_value_types_strings_alloc(
    struct repeated_message_scalar_value_types_t *self_p,
    int length);

int repeated_message_scalar_value_types_bytess_alloc(
    struct repeated_message_scalar_value_types_t *self_p,
    int length);

/**
 * Create a new message repeated.MessageScalarValueTypes in given workspace.
 *
 * @param[in] workspace_p Message workspace.
 * @param[in] size Workspace size.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct repeated_message_scalar_value_types_t *
repeated_message_scalar_value_types_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message repeated.MessageScalarValueTypes.
 *
 * @param[in] self_p Message to encode.
 * @param[out] encoded_p Buffer to encode the message into.
 * @param[in] size Encoded buffer size.
 *
 * @return Encoded data length or negative error code.
 */
int repeated_message_scalar_value_types_encode(
    struct repeated_message_scalar_value_types_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message repeated.MessageScalarValueTypes.
 *
 * @param[in,out] self_p Initialized message to decode into.
 * @param[in] encoded_p Buffer to decode.
 * @param[in] size Size of the encoded message.
 *
 * @return Number of bytes decoded or negative error code.
 */
int repeated_message_scalar_value_types_decode(
    struct repeated_message_scalar_value_types_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

#endif
