/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2019 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by pbtools.
 */

#ifndef SERVICE_H
#define SERVICE_H

#include "pbtools.h"

/**
 * Message service.Request.
 */
struct service_request_repeated_t {
    int length;
    struct service_request_t **items_pp;
    struct service_request_t *head_p;
    struct service_request_t *tail_p;
};

struct service_request_t {
    struct pbtools_message_base_t base;
    struct pbtools_bytes_t value;
};

/**
 * Message service.Response.
 */
struct service_response_repeated_t {
    int length;
    struct service_response_t **items_pp;
    struct service_response_t *head_p;
    struct service_response_t *tail_p;
};

struct service_response_t {
    struct pbtools_message_base_t base;
    struct pbtools_bytes_t value;
};

/**
 * Create a new message service.Request in given workspace.
 *
 * @param[in] workspace_p Message workspace.
 * @param[in] size Workspace size.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct service_request_t *
service_request_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message service.Request.
 *
 * @param[in] self_p Message to encode.
 * @param[out] encoded_p Buffer to encode the message into.
 * @param[in] size Encoded buffer size.
 *
 * @return Encoded data length or negative error code.
 */
int service_request_encode(
    struct service_request_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message service.Request.
 *
 * @param[in,out] self_p Initialized message to decode into.
 * @param[in] encoded_p Buffer to decode.
 * @param[in] size Size of the encoded message.
 *
 * @return Number of bytes decoded or negative error code.
 */
int service_request_decode(
    struct service_request_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

/**
 * Create a new message service.Response in given workspace.
 *
 * @param[in] workspace_p Message workspace.
 * @param[in] size Workspace size.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct service_response_t *
service_response_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message service.Response.
 *
 * @param[in] self_p Message to encode.
 * @param[out] encoded_p Buffer to encode the message into.
 * @param[in] size Encoded buffer size.
 *
 * @return Encoded data length or negative error code.
 */
int service_response_encode(
    struct service_response_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message service.Response.
 *
 * @param[in,out] self_p Initialized message to decode into.
 * @param[in] encoded_p Buffer to decode.
 * @param[in] size Size of the encoded message.
 *
 * @return Number of bytes decoded or negative error code.
 */
int service_response_decode(
    struct service_response_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

#endif
