/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2019 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by pbtools.
 */

#ifndef TAGS_H
#define TAGS_H

#include "pbtools.h"

/**
 * Message tags.Message1.
 */
struct tags_message1_repeated_t {
    int length;
    struct tags_message1_t **items_pp;
    struct tags_message1_t *head_p;
    struct tags_message1_t *tail_p;
};

struct tags_message1_t {
    struct pbtools_message_base_t base;
    bool value;
};

/**
 * Message tags.Message2.
 */
struct tags_message2_repeated_t {
    int length;
    struct tags_message2_t **items_pp;
    struct tags_message2_t *head_p;
    struct tags_message2_t *tail_p;
};

struct tags_message2_t {
    struct pbtools_message_base_t base;
    bool value;
};

/**
 * Message tags.Message3.
 */
struct tags_message3_repeated_t {
    int length;
    struct tags_message3_t **items_pp;
    struct tags_message3_t *head_p;
    struct tags_message3_t *tail_p;
};

struct tags_message3_t {
    struct pbtools_message_base_t base;
    bool value;
};

/**
 * Message tags.Message4.
 */
struct tags_message4_repeated_t {
    int length;
    struct tags_message4_t **items_pp;
    struct tags_message4_t *head_p;
    struct tags_message4_t *tail_p;
};

struct tags_message4_t {
    struct pbtools_message_base_t base;
    bool value;
};

/**
 * Message tags.Message5.
 */
struct tags_message5_repeated_t {
    int length;
    struct tags_message5_t **items_pp;
    struct tags_message5_t *head_p;
    struct tags_message5_t *tail_p;
};

struct tags_message5_t {
    struct pbtools_message_base_t base;
    bool value;
};

/**
 * Message tags.Message6.
 */
struct tags_message6_repeated_t {
    int length;
    struct tags_message6_t **items_pp;
    struct tags_message6_t *head_p;
    struct tags_message6_t *tail_p;
};

struct tags_message6_t {
    struct pbtools_message_base_t base;
    bool value;
};

/**
 * Create a new message tags.Message1 in given workspace.
 *
 * @param[in] workspace_p Message workspace.
 * @param[in] size Workspace size.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct tags_message1_t *
tags_message1_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message tags.Message1.
 *
 * @param[in] self_p Message to encode.
 * @param[out] encoded_p Buffer to encode the message into.
 * @param[in] size Encoded buffer size.
 *
 * @return Encoded data length or negative error code.
 */
int tags_message1_encode(
    struct tags_message1_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message tags.Message1.
 *
 * @param[in,out] self_p Initialized message to decode into.
 * @param[in] encoded_p Buffer to decode.
 * @param[in] size Size of the encoded message.
 *
 * @return Number of bytes decoded or negative error code.
 */
int tags_message1_decode(
    struct tags_message1_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

/**
 * Create a new message tags.Message2 in given workspace.
 *
 * @param[in] workspace_p Message workspace.
 * @param[in] size Workspace size.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct tags_message2_t *
tags_message2_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message tags.Message2.
 *
 * @param[in] self_p Message to encode.
 * @param[out] encoded_p Buffer to encode the message into.
 * @param[in] size Encoded buffer size.
 *
 * @return Encoded data length or negative error code.
 */
int tags_message2_encode(
    struct tags_message2_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message tags.Message2.
 *
 * @param[in,out] self_p Initialized message to decode into.
 * @param[in] encoded_p Buffer to decode.
 * @param[in] size Size of the encoded message.
 *
 * @return Number of bytes decoded or negative error code.
 */
int tags_message2_decode(
    struct tags_message2_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

/**
 * Create a new message tags.Message3 in given workspace.
 *
 * @param[in] workspace_p Message workspace.
 * @param[in] size Workspace size.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct tags_message3_t *
tags_message3_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message tags.Message3.
 *
 * @param[in] self_p Message to encode.
 * @param[out] encoded_p Buffer to encode the message into.
 * @param[in] size Encoded buffer size.
 *
 * @return Encoded data length or negative error code.
 */
int tags_message3_encode(
    struct tags_message3_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message tags.Message3.
 *
 * @param[in,out] self_p Initialized message to decode into.
 * @param[in] encoded_p Buffer to decode.
 * @param[in] size Size of the encoded message.
 *
 * @return Number of bytes decoded or negative error code.
 */
int tags_message3_decode(
    struct tags_message3_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

/**
 * Create a new message tags.Message4 in given workspace.
 *
 * @param[in] workspace_p Message workspace.
 * @param[in] size Workspace size.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct tags_message4_t *
tags_message4_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message tags.Message4.
 *
 * @param[in] self_p Message to encode.
 * @param[out] encoded_p Buffer to encode the message into.
 * @param[in] size Encoded buffer size.
 *
 * @return Encoded data length or negative error code.
 */
int tags_message4_encode(
    struct tags_message4_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message tags.Message4.
 *
 * @param[in,out] self_p Initialized message to decode into.
 * @param[in] encoded_p Buffer to decode.
 * @param[in] size Size of the encoded message.
 *
 * @return Number of bytes decoded or negative error code.
 */
int tags_message4_decode(
    struct tags_message4_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

/**
 * Create a new message tags.Message5 in given workspace.
 *
 * @param[in] workspace_p Message workspace.
 * @param[in] size Workspace size.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct tags_message5_t *
tags_message5_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message tags.Message5.
 *
 * @param[in] self_p Message to encode.
 * @param[out] encoded_p Buffer to encode the message into.
 * @param[in] size Encoded buffer size.
 *
 * @return Encoded data length or negative error code.
 */
int tags_message5_encode(
    struct tags_message5_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message tags.Message5.
 *
 * @param[in,out] self_p Initialized message to decode into.
 * @param[in] encoded_p Buffer to decode.
 * @param[in] size Size of the encoded message.
 *
 * @return Number of bytes decoded or negative error code.
 */
int tags_message5_decode(
    struct tags_message5_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

/**
 * Create a new message tags.Message6 in given workspace.
 *
 * @param[in] workspace_p Message workspace.
 * @param[in] size Workspace size.
 *
 * @return Initialized address book, or NULL on failure.
 */
struct tags_message6_t *
tags_message6_new(
    void *workspace_p,
    size_t size);

/**
 * Encode message tags.Message6.
 *
 * @param[in] self_p Message to encode.
 * @param[out] encoded_p Buffer to encode the message into.
 * @param[in] size Encoded buffer size.
 *
 * @return Encoded data length or negative error code.
 */
int tags_message6_encode(
    struct tags_message6_t *self_p,
    uint8_t *encoded_p,
    size_t size);

/**
 * Decode message tags.Message6.
 *
 * @param[in,out] self_p Initialized message to decode into.
 * @param[in] encoded_p Buffer to decode.
 * @param[in] size Size of the encoded message.
 *
 * @return Number of bytes decoded or negative error code.
 */
int tags_message6_decode(
    struct tags_message6_t *self_p,
    const uint8_t *encoded_p,
    size_t size);

#endif
